# Copyright (c) 2018-present by Michael Herwig <michael.herwig@hotmail.de>
# All rights reserved.

find_program(CMAKE_C_COMPILER gcc-8)

if(NOT CMAKE_C_COMPILER)
    message(FATAL_ERROR "gcc-9 not found.")
endif()

set(CMAKE_C_COMPILER "${CMAKE_C_COMPILER}" CACHE INTERNAL "" FORCE)

find_program(CMAKE_CXX_COMPILER g++-8)

if(NOT CMAKE_CXX_COMPILER)
    message(FATAL_ERROR "g++-9 not found.")
endif()

set(CMAKE_CXX_COMPILER "${CMAKE_CXX_COMPILER}" CACHE INTERNAL "" FORCE)

set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "")

set(CMAKE_C_STANDARD 11 CACHE INTERNAL "")
set(CMAKE_C_STANDARD_REQUIRED ON CACHE INTERNAL "")
set(CMAKE_C_EXTENSIONS ON CACHE INTERNAL "")
set(CMAKE_CXX_STANDARD 17 CACHE INTERNAL "")
set(CMAKE_CXX_STANDARD_REQUIRED YES CACHE INTERNAL "")
set(CMAKE_CXX_EXTENSIONS OFF CACHE INTERNAL "")

set(CMAKE_C_FLAGS_DEBUG "-m64 -g -D_DEBUG -fno-omit-frame-pointer" CACHE INTERNAL "")
set(CMAKE_C_FLAGS_RELEASE "-m64 -O3 -DNDEBUG" CACHE INTERNAL "")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "-m64 -O2 -g -DNDEBUG" CACHE INTERNAL "")
set(CMAKE_C_FLAGS_MINSIZEREL "-m64 -Os -DNDEBUG" CACHE INTERNAL "")

set(CMAKE_CXX_FLAGS_DEBUG "-m64 -g -D_DEBUG -fno-omit-frame-pointer" CACHE INTERNAL "")
set(CMAKE_CXX_FLAGS_RELEASE "-m64 -O3 -DNDEBUG" CACHE INTERNAL "")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-m64 -O2 -g -DNDEBUG" CACHE INTERNAL "")
set(CMAKE_CXX_FLAGS_MINSIZEREL "-m64 -Os -DNDEBUG" CACHE INTERNAL "")

set(CMAKE_EXEC_LINKER_FLAGS_DEBUG "-static-libgcc -static-libstdc++")
set(CMAKE_EXEC_LINKER_FLAGS_RELEASE "-static-libgcc -static-libstdc++")
set(CMAKE_EXEC_LINKER_FLAGS_RELWITHDEBINFO "-static-libgcc -static-libstdc++")
set(CMAKE_EXEC_LINKER_FLAGS_MINSIZEREL "-static-libgcc -static-libstdc++")